<?php

class CoreException extends Exception {

	/**
	* This method doesn't exist
	*/
	const INVALID_API_METHOD = 1000;

		/**
	* This method is forbidden from public interface
	*/
	const UNAUTHORIZED_API_METHOD = 1001;

	private $debug ='';

	public function __construct($code, $complement='', $debug=null) {

		$message = '';

		switch ($code) {
			case CoreException::INVALID_API_METHOD : $message = "This API method doesn't exist"; break;
			case CoreException::UNAUTHORIZED_API_METHOD : $message = "This API method isn't allowed"; break;
			
			default : $message = "An unknown core error happened"; break;
		}

		if (!empty($complement)) {
			$message .= "[".$complement."]";
		}

		$this->debug = $debug;

		parent::__construct($message, $code);

	}

	public function getDebug() {
		return $this->debug;
	}
}
